/******************************************************************************************


		MCD03_CtrlSample.cpp 

						2010.11.28 M.Utumsi@ArcDevice


^Cg
		MCD03̊{TvvO@Ver 1.0


		L[Ńf[eB𒼐ڎw߂D
		'8'Ńf[eB㏸
		'2'Ńf[eB䉺~
		'5'0ɖ߂D
		'ESC'ŏI

		|eV[^CGR[_́Cf[^͊ZȂ̂̂óD
		gNf[^́Cdf[^ƂďóD

********************************************************************************************/


#include "stdafx.h"
#include<stdio.h>
#include<stdlib.h>
#include<conio.h>
#include"MCD03.h"


// pp[^Fڍׂ͊{vO}jAQƂ̂

MCD03_PARAM Param = {
	//	dt_ms, fCtrlTimeout_ms, fCommTimeout_ms
		1.0f, 1000.0f, 1000.0f,
	//   kp, kd, kv, ki, kt
		1.0f, 0.0f, 1.0f, 1.0f, 1.0f,
	//  fMinEn, fPosLimit_h, fPosLimit_l, fPosOffset
		0.0f, 1023.0f, 0, 0, 
	//  ken[rad/pulse] etc.
		1.0f, 
	// kpt[rad/ad] etc.
		1.0f,
	// ktq [A/ad] etc.
		5.0f/1023.0f
};


int _tmain(int argc, _TCHAR* argv[])
{
	MCD03 mcd;	
	int nVal;
	BOOL loop = TRUE;

	// I[v
	// ƂIDw肵ăI[vD
	// CM_MASTER_IDׂ͂Ă̊D

	printf("Oepn MCD03 ");
	if( !mcd.Open( MCD03_MASTER_ID ) ){
		printf( "%s", mcd.Error );
		return(1);
	}
	printf("OK\r\n");

	// pp[^̐ݒ
	if( !mcd.SetParam( &Param ) ){
		printf( "%s", mcd.Error );
		return(1);
	}

	nVal= 0;

	while(loop){
		if(_kbhit()){
			switch(_getch()){
            case '8': nVal+=10; break;
			case '2': nVal-=10; break;
			case '5': nVal = 0; break;
			case 27: loop = FALSE; break;
			}
		}

		// f[eB[̒ڎw
		if(!mcd.SetDuty( nVal ) ){
			printf("%s", mcd.Error );
			loop =FALSE;
		}

		printf("status %d ", mcd.bStatus );
		printf("nVal %d pos %5.1f vel %5.1f trq %5.3f di %04x\r\n", 
			nVal, mcd.fPosition, mcd.fVelocity, mcd.fTorque, mcd.wDiPort );
	    Sleep(100);

	}

	// ~w
	mcd.Stop();

	//N[Y
	mcd.Close();

	return 0;
}

